/********** mtrr_drv.h ****************/ 
#ifndef MTRR_DRV_H 
#define MTRR_DRV_H 

#include <Drivers.h> 

#ifdef __cplusplus 
extern "C" { 
#endif 

typedef enum 
{ 
  UC_MEM = 0,  /* uncacheable    */ 
  WC_MEM = 1, /* write combining  */ 
  WT_MEM = 4,  /* write-through  */ 
  WP_MEM = 5, /* write-protected  */ 
  WB_MEM = 6  /* writeback    */ 
} MEM_TYPE; 

typedef enum 
{ 
  RANGE_CLEAR, 
  RANGE_SET 
} RANGE_ACTION; 

typedef struct 
{ 
  RANGE_ACTION  action;  /* clear/set */ 
  uint64    base; 
  uint64    len; 
  MEM_TYPE  mem_type; 
} mtrr_drv_command_t; 
/* len has to be a power of 2 and base has to be aligned 
 on at least len boundary. The minimum len is 4 KByte. */ 

enum 
{ 
  MTTR_DRV_COMMAND = B_DEVICE_OP_CODES_END + 1 
}; 

#ifdef __cplusplus 
} 
#endif 

#endif 
